<?php
require_once('PleskException.php');

class kavmng extends errHandler {

function cmd($args)
{
	$cmdstr = 'kavmng';
	$rv = util_exec($cmdstr, $args);

	if ( $rv === false) {
		global $plesk_errormsg;

		foreach ($args AS $arg) {
			$cmdstr .= ' ';
			$cmdstr .= $arg;
		}
		throw new PleskFatalException($cmdstr . ' failed: ' . $plesk_errormsg);
		return $rv;
	}
	return sizeof($rv) > 0 ? $rv : true;
}

function applyStatus($status, $addr, $addr_id = null) {
	static $cmds = array(
		VirusFilterUserController::STATUS_NONE => array("remove"),
		VirusFilterUserController::STATUS_INCOMING => array("add", "incoming"),
		VirusFilterUserController::STATUS_OUTGOING => array("add", "outgoing"),
		VirusFilterUserController::STATUS_ANY => array("add", "both") );

    if ($status != VirusFilterUserController::STATUS_NONE) {
        $this->checkLicenseLimit($addr_id);
    }

	$cmd = $cmds[$status];
	$cmd[] =  $addr;
	$this->cmd($cmd);
}

static function getAllDomains($dom_id, $domname) {
	$rs = db_query("SELECT displayName FROM domainaliases WHERE dom_id = {$dom_id} AND mail='true'");
	$rv = array($domname);
	while ($rec = mysql_fetch_object($rs)) {
		$rv[] = $rec->displayName;
	}

	return $rv;
}

static function getAllMails($dom_id) {
	$rs = db_query("SELECT id, mail_name, virusfilter FROM mail WHERE dom_id = {$dom_id} AND virusfilter != 'none'");
	$rv = array();
	while ($rec = mysql_fetch_object($rs)) {
		$rv[] = array('id' => $rec->id, 'name' => $rec->mail_name, 'filter' => $rec->virusfilter);
	}
	$rs = db_query("SELECT mn.id, ma.alias, mn.virusfilter FROM mail_aliases ma JOIN mail mn ON (mn.id = ma.mn_id) WHERE mn.dom_id = {$dom_id} AND mn.virusfilter != 'none'");
	while ($rec = mysql_fetch_object($rs)) {
		$rv[] = array('id' => $rec->id, 'name' => $rec->alias, 'filter' => $rec->virusfilter);
	}

	return $rv;
}

static function key_installed()
{
	return file_exists("/opt/kav/sdk8l3/bin/kav.key")
	   && of_get_key_by_product("kav-unix");
}

    public function getAvailableLicenseMailnames($addr_id = null)
    {
        $license_limit = $this->getLicenseLimit();

        $query = 'SELECT COUNT(`id`) FROM `mail` WHERE `virusfilter` != "' . VirusFilterUserController::STATUS_NONE . '"';
        if ($addr_id) {
            $query .= ' AND id != ' . $addr_id;
        }
        list($filtered_mailnames_count) = db_fetch($query);

        return  ($license_limit - intval($filtered_mailnames_count));
    }

    public function getLicenseLimit()
    {
        if (!self::key_installed()) {
            throw new PleskLicenseKeyException('The required Kaspersky additional key is not installed');
        }

        $kav_key = pkey_fetch_key('antivir-kav');
        return intval($kav_key['key_mailboxes']);
    }

    public function checkLicenseLimit($addr_id = null)
    {
        if ($this->getAvailableLicenseMailnames($addr_id) <= 0) {
            throw new PleskLicenseLimitException('You have reached the limit on number of mailboxes defined by your Kaspersky license key (' . $this->getLicenseLimit() . ')');
        }
    }
};


?>
